import hal
import glib
import hal_glib
import time
import gtk # for image references
import gladevcp.persistence
from inspect import stack

def __init__(self, halcomp,builder,useropts):
    self.halcomp = halcomp
    self.builder = builder
    self.useropts = useropts
    self.defaults = {
        # the following names will be saved/restored as method attributes
        # the save/restore mechanism is strongly typed - the variables type will be derived from the type of the
        # initialization value. Currently supported types are: int, float, bool, string
        #IniFile.vars : { 'nhits' : 0, 'a': 1.67, 'd': True ,'c' : "a string"},
        #IniFile.vars : { 'adj_spin_z1' : 0, 'adj_spin_z2': 0, 'adj_spin_z3': 0, 'adj_spin_z4' : 0 'adj_spin_z5' : 0 'adj_spin_z6' : 0 'adj_spin_z7' : 0 'adj_spin_z8' : 0},
        # to save/restore all widget's state which might remotely make sense, add this:
        IniFile.widgets : widget_defaults(builder.get_objects())
        # a sensible alternative might be to retain only all HAL output widgets' state:
        # IniFile.widgets: widget_defaults(select_widgets(self.builder.get_objects(), hal_only=True,output_only = True)),
    }
    
self.ini_filename = __name__ + '.ini'
self.ini = IniFile(self.ini_filename,self.defaults,self.builder)
self.ini.restore_state(self)

def on_destroy(self,obj,data=None):
    self.ini.save_state(self)    
